/*
   Read from standard input while
   also writing to standard output.

   In this version, you can type Control-z followed
   by the Enter key to stop this program.
*/

import java.util.Scanner;

public class ReadingWhileWriting_v1a
{
   private static Thread mainThread = Thread.currentThread();

   public static void main(String[] args)
   {
      final ReaderTask readerTask = new ReaderTask();
      final Thread readerThread = new Thread(readerTask);

      readerThread.start();

      while (! Thread.currentThread().isInterrupted())
      {
         System.out.print( readerTask.c );
      }
   }


   static class ReaderTask implements Runnable
   {
      private final Scanner stdin = new Scanner(System.in);
      private char c = 'a';

      @Override
      public void run()
      {
         while (stdin.hasNext()) // This blocks (until end-of-stream).
         {
            c = stdin.next().charAt(0);
         }
         mainThread.interrupt();
      }
   }
}
