/*
   Read from standard input while
   also writing to standard output.
*/

import java.util.Scanner;
import java.util.concurrent.Future;
import java.util.concurrent.Callable;
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.CompletionService;
import java.util.concurrent.ExecutorCompletionService;

public class ReadingWhileWriting_v3a
{
   public static void main(String[] args) throws InterruptedException, ExecutionException
   {
      final ExecutorService pool = Executors.newFixedThreadPool(1);
      final CompletionService<Character> cs = new ExecutorCompletionService<>(pool);
      final Scanner stdin = new Scanner(System.in);
      // Use a lambda expression for the callable task.
      Future<Character> futureChar = cs.submit( () -> stdin.next().charAt(0) );

      char c = 'a';
      while (true)
      {
         while ( ! futureChar.isDone() ) // a polling loop
         {
            System.out.print( c );
         }
         c = futureChar.get();
         futureChar = cs.submit(() -> stdin.next().charAt(0)); // set up another future value
      }
   }
}
