/*
   Read from standard input while
   also writing to standard output.
*/

import java.util.Scanner;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;

public class ReadingWhileWriting_v4
{
   public static void main(String[] args) throws InterruptedException, ExecutionException
   {
      final Scanner stdin = new Scanner(System.in);
      // Use a lambda expression for the callable task.
      CompletableFuture<Character> futureChar =
                CompletableFuture.supplyAsync( () -> stdin.next().charAt(0) );

      char c = 'a';
      while (true)
      {
         while ( ! futureChar.isDone() ) // a polling loop
         {
            System.out.print( c );
         }
         c = futureChar.get();
         futureChar = CompletableFuture.supplyAsync( () -> stdin.next().charAt(0) );
      }
   }
}
